#include <iostream>
#include <memory>
#include <antlr4-runtime.h>

#include "antlr4_gen/LabeledExprParser.h"
#include "antlr4_gen/LabeledExprLexer.h"
#include "antlr4_gen/LabeledExprBaseVisitor.h"

#include "labeled_expr_eval_visitor.h"

int main(){
    auto input_ptr = std::make_shared<antlr4::ANTLRInputStream >(std::cin);
    auto lexer_ptr = std::make_shared<LabeledExprLexer>(input_ptr.get());
    auto tokens_ptr= std::make_shared<antlr4::CommonTokenStream>(lexer_ptr.get());
    auto parser_ptr= std::make_shared<LabeledExprParser>(tokens_ptr.get());
    auto tree_bare_ptr = parser_ptr->prog();

    std::cout << tree_bare_ptr->toStringTree(parser_ptr.get()) << std::endl;

    LabeledExprEvalVisitor eval_vistor;
    auto ret = eval_vistor.visit(tree_bare_ptr);

    //std::cout << ret.as<LabeledExprVisitor*>()-> << std::endl;
}